unit hiImg_Rotate; {      } 

interface

uses Windows, Kol,Share,Debug;

type   TLine = array[0..0]of byte;
       PLine = ^TLine;

       TByteArray    = array[Word]of Byte;
       PByteArray    =^TByteArray;
         
type
  THIImg_Rotate = class(TDebug)
    private
      FDataWidth:TData;
      FDataHeight:TData;
      procedure setFData(W:Integer; H:Integer);
    public
      _prop_angle:real;
      _prop_BackgroundColor:integer;
      _data_Bitmap:THI_Event;
      _data_angle:THI_Event;
      _data_BackgroundColor:THI_Event;
      _event_onResult:THI_Event;
      procedure _work_doRotate(var _Data:TData; Index:word);
      procedure _work_doFlipVertical(var _Data:TData; Index:word);
      procedure _work_doFlipHorizontal(var _Data:TData; Index:word);
      procedure _var_Width(var _Data:TData; Index:word);
      procedure _var_Height(var _Data:TData; Index:word);
    end;
implementation

procedure THIImg_Rotate._work_doRotate;
var   color:integer;
      bmp,scr1,scr2:PBitmap;
      angle:real;

      function Point(x:Integer; y:Integer): TPoint;
      begin 
         Result.x := x; 
         Result.y := y; 
      end;

      function RotImage(scr:PBitmap; angle:real; Color:TColor): PBitmap;
      var   res: PBitmap;
            highest, lowest, mostleft, mostright: TPoint; 
            topoverh, leftoverh: integer; 
            x, y, k, H, W, newx, newy: integer;
            cosA:real;
            sinA:real;
            Sor,Des: PLine;
      begin
         H := scr.Height;
         W := scr.Width; 
         if (angle <= (pi / 2)) then begin 
            highest := Point(0,0);
            lowest := Point(W,H);
            mostleft := Point(0,H);
            mostright := Point(W,0);
         end else if (angle <= pi) then begin 
            highest := Point(0,H); 
            lowest := Point(W,0); 
            mostleft := Point(W,H); 
            mostright := Point(0,0); 
         end else if (angle <= (pi * 3 / 2)) then begin 
            highest := Point(W,H); 
            lowest := Point(0,0); 
            mostleft := Point(W, 0); 
            mostright := Point(0,H); 
         end else begin 
            highest := Point(W, 0); 
            lowest := Point(0,H); 
            mostleft := Point(0,0); 
            mostright := Point(W,H); 
         end;
         cosA := cos(angle);
         sinA := sin(angle);

         topoverh := Round(highest.x * sinA + highest.y * cosA); 
         leftoverh := Round(mostleft.x * cosA - mostleft.y * sinA); 

         y := Abs(Round(lowest.x * sinA + lowest.y * cosA)) + Abs(topoverh) + 2; 
         x := Abs(Round(mostright.x * cosA - mostright.y * sinA)) + Abs(leftoverh) + 2;
         res := NewDIBBitmap(x, y, pf24bit);
         res.Canvas.Brush.Color := Color;
         FillRect(res.Canvas.handle, res.BoundsRect, res.Canvas.Brush.Handle);
         for y := 0 to H - 1 do begin
            Sor := scr1.ScanLine[y];
            for x := 0 to W - 1 do begin
               newX := Abs(Round(x * cosA - y * sinA) - leftoverh) * 3; 
               newY := Round(x * sinA + y * cosA) - topoverh;
               k := x shl 2;
               Des := res.ScanLine[newY];
               Des[newx] := Sor[k];     //B
               Des[newx+1] := Sor[k+1]; //G
               Des[newx+2] := Sor[k+2]; //R
               Des := res.ScanLine[newY + 1];
               Des[newx] := Sor[k];     //B
               Des[newx+1] := Sor[k+1]; //G
               Des[newx+2] := Sor[k+2]; //R
            end;
         end;
         Result := res;
      end;      
      
begin
   bmp := ReadBitmap(_Data,_data_Bitmap,nil);
   if (bmp = nil) or bmp.Empty then exit;
   angle := ReadReal(_Data,_data_angle,_prop_angle);
   color := ReadInteger(_Data,_data_BackgroundColor,_prop_BackgroundColor);

   while angle > 360 do angle := angle - 360;
   while angle < 0 do angle := angle + 360;

   scr1 := NewDIBBitmap(bmp.Width, bmp.Height, pf32bit);
   scr1.Assign(bmp);
   scr1.PixelFormat := pf32bit;

   case Round(angle) of
      0,360: ;
      90:  scr1.RotateRightTrueColor;
      270: scr1.RotateLeftTrueColor;
      180: begin
           scr1.RotateRightTrueColor;
           scr1.RotateRightTrueColor;
      end else begin
         angle := angle*Pi/180;
         scr2 := RotImage(scr1, angle, color);
         setFData(scr2.Width, scr2.Height);
         _hi_OnEvent(_event_onResult, scr2);
         scr1.Free;
         scr2.Free;
         exit; 
      end;
   end;
   setFData(scr1.Width, scr1.Height);
   _hi_OnEvent(_event_onResult, scr1);
   scr1.Free;
end;

procedure THIImg_Rotate._work_doFlipVertical;
var    bmp,scr1:PBitmap;
begin
   bmp := ReadBitmap(_Data,_data_Bitmap,nil);
   if (bmp = nil) or bmp.Empty then exit;
   scr1 := NewDIBBitmap(bmp.Width, bmp.Height, pf32bit);
   scr1.Assign(bmp);
   scr1.FlipVertical;
   setFData(scr1.Width, scr1.Height);
   _hi_onEvent(_event_onResult, scr1);
   scr1.Free;
end;

procedure THIImg_Rotate._work_doFlipHorizontal;
var    bmp,scr1:PBitmap;
begin
   bmp := ReadBitmap(_Data,_data_Bitmap,nil);
   if (bmp = nil) or bmp.Empty then exit;
   scr1 := NewDIBBitmap(bmp.Width, bmp.Height, pf32bit);
   scr1.Assign(bmp);
   scr1.FlipHorizontal;
   setFData(scr1.Width, scr1.Height);
   _hi_onEvent(_event_onResult, scr1);
   scr1.Free;
end;

procedure THIImg_Rotate.setFData(W:Integer; H:Integer);
begin
   dtInteger(FDataWidth, Round(W)); 
   dtInteger(FDataHeight, Round(H));
end;

procedure THIImg_Rotate._var_Width;
begin
   _Data := FDataWidth;
end;

procedure THIImg_Rotate._var_Height;
begin
   _Data := FDataHeight;
end;

end.
